<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>LibraryMgr: models/People/Admin/Admin.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="logo_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">LibraryMgr
   &#160;<span id="projectnumber">0.4</span>
   </div>
   <div id="projectbrief">Library manager desktop app</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_admin_8h_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Admin.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#ifndef LIBRARYMGR_ADMIN_H</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#define LIBRARYMGR_ADMIN_H</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#include &quot;../User/User.h&quot;</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#include &quot;../../Database/Database.h&quot;</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#include &quot;../../../utils/SmartPointer/SmartPointer.h&quot;</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;</div><div class="line"><a name="l00030"></a><span class="lineno"><a class="line" href="class_admin.html">   30</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_admin.html">Admin</a> : <span class="keyword">public</span> <a class="code" href="class_user.html">User</a> {</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    <span class="comment">// constructors</span></div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    <a class="code" href="class_admin.html#add5f3d47d70f73f496ec38e236e18f12">Admin</a>(</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;            std::string name,</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;            std::string surname,</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;            QDate date,</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;            std::string email,</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;            <a class="code" href="class_database.html">Database</a>&lt;<a class="code" href="class_smart_pointer.html">SmartPointer&lt;Book&gt;</a>&gt; *books,</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;            <a class="code" href="class_database.html">Database</a>&lt;<a class="code" href="class_smart_pointer.html">SmartPointer&lt;User&gt;</a>&gt; *users</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    );</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    <a class="code" href="class_admin.html#add5f3d47d70f73f496ec38e236e18f12">Admin</a>(<span class="keyword">const</span> <a class="code" href="class_admin.html">Admin</a> &amp;a);</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    <a class="code" href="class_admin.html#add5f3d47d70f73f496ec38e236e18f12">Admin</a>(<a class="code" href="class_smart_pointer.html">SmartPointer&lt;User&gt;</a> u);</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    <a class="code" href="class_admin.html#add5f3d47d70f73f496ec38e236e18f12">Admin</a>(<a class="code" href="class_smart_pointer.html">SmartPointer&lt;User&gt;</a> u, <a class="code" href="class_database.html">Database</a>&lt;<a class="code" href="class_smart_pointer.html">SmartPointer&lt;Book&gt;</a>&gt; *books,</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;          <a class="code" href="class_database.html">Database</a>&lt;<a class="code" href="class_smart_pointer.html">SmartPointer&lt;User&gt;</a>&gt; *users);  <span class="comment">// to make admin a simple user</span></div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    <a class="code" href="class_admin.html#a8fb5fe72fb4e05d50980c13cdf3b779c">~Admin</a>();</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    <span class="comment">// books</span></div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_admin.html#a4a64c486c9db82942a3cf2b9591d43bc">addBook</a>(<a class="code" href="class_smart_pointer.html">SmartPointer&lt;Book&gt;</a> book);</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_admin.html#ab5abc30d4feddbe7c6ae34743378c995">removeBook</a>(<a class="code" href="class_smart_pointer.html">SmartPointer&lt;Book&gt;</a> book);</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_admin.html#a19ccdf33fc763617f77c6ec7ccea46c3">replaceBook</a>(<a class="code" href="class_smart_pointer.html">SmartPointer&lt;Book&gt;</a> oldBook, <a class="code" href="class_smart_pointer.html">SmartPointer&lt;Book&gt;</a> newBook);</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;    <span class="comment">// users</span></div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_admin.html#abdb263f503e23f5ef2bbf140092b305e">addUser</a>(<a class="code" href="class_smart_pointer.html">SmartPointer&lt;User&gt;</a> user);</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_admin.html#a2cd28597301d7c6e3acc5923055b0956">removeUser</a>(<a class="code" href="class_smart_pointer.html">SmartPointer&lt;User&gt;</a> user);</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;    <a class="code" href="class_smart_pointer.html">SmartPointer&lt;User&gt;</a> <a class="code" href="class_admin.html#a800d579a5b22fdfc4e05ba595f46667f">makeAdmin</a>(<a class="code" href="class_user.html">User</a> *u);</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    <span class="comment">// operators</span></div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;    <a class="code" href="class_admin.html">Admin</a> &amp;<a class="code" href="class_admin.html#a4e451f158e0c497042b9d8391e23c829">operator=</a>(<span class="keyword">const</span> <a class="code" href="class_admin.html">Admin</a> &amp;a);</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;    <span class="keyword">friend</span> std::ostream &amp;<a class="code" href="class_admin.html#ab50d4206f7748ecb4dad7c3734322c97">operator&lt;&lt;</a>(std::ostream &amp;out, <span class="keyword">const</span> <a class="code" href="class_admin.html">Admin</a> &amp;admin);</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;    <span class="keyword">friend</span> std::ostream &amp;<a class="code" href="class_admin.html#ab50d4206f7748ecb4dad7c3734322c97">operator&lt;&lt;</a>(std::ostream &amp;out, <span class="keyword">const</span> <a class="code" href="class_admin.html">Admin</a> *admin);</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;    <a class="code" href="class_database.html">Database&lt;SmartPointer&lt;Book&gt;</a>&gt; *books;  <span class="comment">// database of books</span></div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;    <a class="code" href="class_database.html">Database&lt;SmartPointer&lt;User&gt;</a>&gt; *users;  <span class="comment">// list of users in library</span></div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;};</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;<span class="preprocessor">#endif // LIBRARYMGR_ADMIN_H</span></div><div class="ttc" id="class_admin_html_ab5abc30d4feddbe7c6ae34743378c995"><div class="ttname"><a href="class_admin.html#ab5abc30d4feddbe7c6ae34743378c995">Admin::removeBook</a></div><div class="ttdeci">void removeBook(SmartPointer&lt; Book &gt; book)</div><div class="ttdoc">adds new book to library </div><div class="ttdef"><b>Definition:</b> Admin.cpp:65</div></div>
<div class="ttc" id="class_admin_html"><div class="ttname"><a href="class_admin.html">Admin</a></div><div class="ttdoc">A library user who is also an admin (i.e can manage books of library) </div><div class="ttdef"><b>Definition:</b> Admin.h:30</div></div>
<div class="ttc" id="class_user_html"><div class="ttname"><a href="class_user.html">User</a></div><div class="ttdef"><b>Definition:</b> User.h:31</div></div>
<div class="ttc" id="class_admin_html_a2cd28597301d7c6e3acc5923055b0956"><div class="ttname"><a href="class_admin.html#a2cd28597301d7c6e3acc5923055b0956">Admin::removeUser</a></div><div class="ttdeci">void removeUser(SmartPointer&lt; User &gt; user)</div><div class="ttdoc">adds new user to library </div><div class="ttdef"><b>Definition:</b> Admin.cpp:77</div></div>
<div class="ttc" id="class_admin_html_a8fb5fe72fb4e05d50980c13cdf3b779c"><div class="ttname"><a href="class_admin.html#a8fb5fe72fb4e05d50980c13cdf3b779c">Admin::~Admin</a></div><div class="ttdeci">~Admin()</div><div class="ttdoc">~Admin Destroy admin fields (but not shared books library) </div><div class="ttdef"><b>Definition:</b> Admin.cpp:59</div></div>
<div class="ttc" id="class_admin_html_a19ccdf33fc763617f77c6ec7ccea46c3"><div class="ttname"><a href="class_admin.html#a19ccdf33fc763617f77c6ec7ccea46c3">Admin::replaceBook</a></div><div class="ttdeci">void replaceBook(SmartPointer&lt; Book &gt; oldBook, SmartPointer&lt; Book &gt; newBook)</div><div class="ttdoc">replaces old books with new books </div><div class="ttdef"><b>Definition:</b> Admin.cpp:69</div></div>
<div class="ttc" id="class_admin_html_abdb263f503e23f5ef2bbf140092b305e"><div class="ttname"><a href="class_admin.html#abdb263f503e23f5ef2bbf140092b305e">Admin::addUser</a></div><div class="ttdeci">void addUser(SmartPointer&lt; User &gt; user)</div><div class="ttdoc">adds new user to library </div><div class="ttdef"><b>Definition:</b> Admin.cpp:73</div></div>
<div class="ttc" id="class_admin_html_a800d579a5b22fdfc4e05ba595f46667f"><div class="ttname"><a href="class_admin.html#a800d579a5b22fdfc4e05ba595f46667f">Admin::makeAdmin</a></div><div class="ttdeci">SmartPointer&lt; User &gt; makeAdmin(User *u)</div><div class="ttdoc">makes user an admin </div><div class="ttdef"><b>Definition:</b> Admin.cpp:81</div></div>
<div class="ttc" id="class_database_html"><div class="ttname"><a href="class_database.html">Database</a></div><div class="ttdoc">Abstract collection of object. </div><div class="ttdef"><b>Definition:</b> Database.h:30</div></div>
<div class="ttc" id="class_admin_html_a4a64c486c9db82942a3cf2b9591d43bc"><div class="ttname"><a href="class_admin.html#a4a64c486c9db82942a3cf2b9591d43bc">Admin::addBook</a></div><div class="ttdeci">void addBook(SmartPointer&lt; Book &gt; book)</div><div class="ttdoc">adds new book to library </div><div class="ttdef"><b>Definition:</b> Admin.cpp:61</div></div>
<div class="ttc" id="class_admin_html_a4e451f158e0c497042b9d8391e23c829"><div class="ttname"><a href="class_admin.html#a4e451f158e0c497042b9d8391e23c829">Admin::operator=</a></div><div class="ttdeci">Admin &amp; operator=(const Admin &amp;a)</div><div class="ttdoc">operator = Admin deep copy of person </div><div class="ttdef"><b>Definition:</b> Admin.cpp:48</div></div>
<div class="ttc" id="class_admin_html_ab50d4206f7748ecb4dad7c3734322c97"><div class="ttname"><a href="class_admin.html#ab50d4206f7748ecb4dad7c3734322c97">Admin::operator&lt;&lt;</a></div><div class="ttdeci">friend std::ostream &amp; operator&lt;&lt;(std::ostream &amp;out, const Admin &amp;admin)</div><div class="ttdoc">operator &lt;&lt; printer </div><div class="ttdef"><b>Definition:</b> Admin.cpp:85</div></div>
<div class="ttc" id="class_smart_pointer_html"><div class="ttname"><a href="class_smart_pointer.html">SmartPointer</a></div><div class="ttdef"><b>Definition:</b> SmartPointer.h:27</div></div>
<div class="ttc" id="class_admin_html_add5f3d47d70f73f496ec38e236e18f12"><div class="ttname"><a href="class_admin.html#add5f3d47d70f73f496ec38e236e18f12">Admin::Admin</a></div><div class="ttdeci">Admin(std::string name, std::string surname, QDate date, std::string email, Database&lt; SmartPointer&lt; Book &gt;&gt; *books, Database&lt; SmartPointer&lt; User &gt;&gt; *users)</div><div class="ttdoc">Admin New Person with email and optional date of birth. </div><div class="ttdef"><b>Definition:</b> Admin.cpp:20</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_1ae4179d5e953611aae20c997279e02c.html">models</a></li><li class="navelem"><a class="el" href="dir_34f7514774f7ab8415d66ae1b257c12f.html">People</a></li><li class="navelem"><a class="el" href="dir_c945351df796bb3eadd18cdfd34c9d71.html">Admin</a></li><li class="navelem"><b>Admin.h</b></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
